Const XFileName = 'X.TXT';
      YFileName = 'Y.TXT';

Type
 pMas = ^RealRec;
          RealRec = RECORD
                N : Real;
                P : pMas;
          End;

Var   X,Y : pMas;
    XB,YB : pMas;
    XE,YE : pMas;
      Eps : Real;

Function StrToReal(s:String):Real;
Var C, D : Integer;
    I, Z, Code : Integer;
    T : String;
    R : Real;
Begin
     C:=0;
     D:=0;
     If Pos('.', s) <> 0 Then Begin
        T := Copy(s, 1, Pos('.', s)-1);
        Val(T, C, code);

        T := Copy(s, Pos('.', s)+1, Length(s));
        Val(T, D, code);
        Z := Length(T);

        R := D;
        For I := 1 To Z Do R := R/10;
        StrToReal := C+R;
     End Else Begin
         Val(S, C, code);
         StrToReal := C;
     End;
End;

Procedure ReadParam;
Begin
     If ParamCount < 1 Then Eps := 0.001
                       Else Eps := StrToReal(ParamStr(1));
End;

Procedure ReadFile;
Var F : Text;
    R : Real;
    S : String;
Begin
     {-= 뢠  ᨢ X =-}
     Assign (F,XFileName);
     ReSet(F);
     ReadLn(F,S);
     R := StrToReal(S);

     New(X);
     X^.N := R;
     X^.P := Nil;
     XB := X;
     XE := X;
     While  Not(Eof(F)) Do Begin
            ReadLn(F,S);
            R := StrToReal(S);
            New(X);
            X^.N := R;
            X^.P := Nil;
            XE^.P := X;
            XE := X;
     End;
     Close(F);

     {-= 뢠  ᨢ Y =-}
     Assign (F,YFileName);
     ReSet(F);
     ReadLn(F,S);
     R := StrToReal(S);

     New(Y);
     Y^.N := R;
     Y^.P := Nil;
     YB := Y;
     YE := Y;
     While  Not(Eof(F)) Do Begin
            ReadLn(F,S);
            R := StrToReal(S);

            New(Y);
            Y^.N := R;
            Y^.P := Nil;
            YE^.P := Y;
            YE := Y;
     End;
     Close(F);
End;

Procedure WriteMas;
Var XN, YN : pMas;
Begin
     {-= 뢠 ᨢ X =-}
     XN := XB;
     While XN<>Nil Do Begin
           Write(XN^.N:2:2,' ');
           XN := XN^.P;
     End;
     WriteLn;

     {-= 뢠 ᨢ Y =-}
     YN := YB;
     While YN<>Nil Do Begin
           Write(YN^.N:2:2,' ');
           YN := YN^.P;
     End;

     ReadLn;
End;

Procedure DeleteMas;
Var I : Byte;
Begin
     I := 0;
  {-= 㡨 ᨢ X =-}
  While XB<>Nil Do
  Begin
       Inc(I);
       WriteLn(I:3,' ',XB^.N:3:4);
    X:=XB^.P;
    Dispose(XB);
    XB := X;
  End;

     I := 0;
  {-= 㡨 ᨢ Y =-}
  While YB<>Nil Do
  Begin
       Inc(I);
       WriteLn(I:3,' ',YB^.N:3:4);
    Y:=YB^.P;
    Dispose(YB);
    YB := Y;
  End;
End;

Procedure Delete(YO:pMas);
Var YN, YPpred : pMas;
begin
     If YB<>YO Then Begin  { ᫨    , ⮣ 㤥 ᪠ }
        YN := YB;
        While (YN<>Nil) and (YN<>YO) Do
        Begin
             YPpred := YN;
             YN:=YN^.P;
        End;
        If YO^.P = Nil Then Begin { ᫥ }
           YPpred^.P:=Nil;
           Dispose(YO);
        End Else Begin            {   ।}
           YPpred^.P:=YN^.P;
           YO := YPpred;
           Dispose(YN);
        End;
     End Else Begin
           YB := YB^.P;
           Dispose(YO);
     End;
End;

Procedure Insert(XO:pMas; N:Real);
Var XN : pMas;
Begin
     New(XN);
     XN^.N := N;
     XN^.P := XO^.P;
     XO^.P:=XN;
End;

Function Next(A:pMas):pMas;
Var YN,Result : pMas;
Begin
     Next := A^.P;
End;

Procedure BetwMas; { ,    ⮢ }
Var XN,Temp : pMas;
    U,D : Real;
Begin
     XN := XB;
     While XN^.P<>Nil Do Begin
           U := XN^.N;
           D := XN^.P^.N;
           Temp := YB;
           While Temp<>Nil Do Begin
           If (Temp^.N - U >= Eps) And
              (D - Temp^.N >= Eps) Then
              Begin
                 Insert(XN,Temp^.N);
                 Delete(Temp);

                 Temp := YB;
                 D := XN^.P^.N;
              End;
              Temp := Next(Temp);
           End;
           XN := XN^.P;
     End;
End;

Function PredExist(Up : Real):pMas; { 室   ᨢ Y }
Var YN,Result : pMas;
    Min : Real;
Begin
     Result := Nil;
     Min := Up;
     YN := YB;
     While (YN<>Nil) Do Begin
           If (YN^.N <= Min) Then Begin
              Result := YN;
              Min := YN^.N;
           End;
           YN := YN^.P;
     End;
     PredExist := Result;
End;

Procedure PredMas; { ,   । ᠬ  ⮬ }
Var XN,Temp : pMas;
    T : Real;
Begin
     XN := XB;
     Temp := PredExist(XB^.N);
     If (Temp<>Nil) And (XB^.N - Temp^.N >= Eps) Then Begin
        Insert(XN,Temp^.N);
            XB := XN;
            T := XN^.N;
            XN^.N := XN^.P^.N;
            XN^.P^.N := T;
        Delete(Temp);
     End;
End;

Function SuccExist(Down : Real):pMas;
                                   { 室 ᨬ  ᨢ Y }
Var YN,Result : pMas;
    Max : Real;
Begin
     Result := Nil;
     Max := Down;
     YN := YB;
     While (YN<>Nil) Do Begin
           If (YN^.N >= Max) Then Begin
              Result := YN;
              Max := YN^.N;
           End;
           YN := YN^.P;
     End;
     SuccExist := Result;
End;

Procedure SuccMas; { ,   ᫥ ᠬ ᫥ ⮬ }
Var XN,Temp : pMas;
    T : Real;
Begin
     XN := XE;
     Temp := SuccExist(XE^.N);
     If (Temp<>Nil) And (Temp^.N - XE^.N >= Eps) Then Begin
        Insert(XN,Temp^.N);
        Delete(Temp);
     End;
End;

Begin
     ReadParam;
     ReadFile;
     PredMas;
     SuccMas;
     BetwMas;
     DeleteMas;
     WriteLn;
     WriteLn('Eps ',Eps:3:4);
     readln;
End.
